//----------------------------------------------------------------------//
//	zbgL[[eBeB[ HotQ										//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

USEFORM("Unit2.cpp", CmdLncForm);
USEFORM("Unit1.cpp", HotQMainForm);
USEFORM("Unit3.cpp", HotKeyHelp);
USEFORM("ClipList.cpp", ClipBdList);

//---------------------------------------------------------------------------
WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR lpCmdLine, int)
{
	//~[ebNXɂdN𔻒
	HANDLE hMutex = ::CreateMutex(NULL,FALSE, _T("HotQ_is_running"));
	if(GetLastError()==ERROR_ALREADY_EXISTS) {
		HWND hPrevWnd = ::FindWindow(_T("THotQMainForm"), NULL);
		if (hPrevWnd) {
			//R}hC̓e𑗂
			COPYDATASTRUCT cd;
			cd.dwData = 1;
			cd.cbData = sizeof(_TCHAR) * (lstrlen(lpCmdLine) + 1);
			cd.lpData = lpCmdLine;
			::SendMessage(hPrevWnd, WM_COPYDATA, 0, (LPARAM)&cd);
		}
		::CloseHandle(hMutex);
		return -1;
	}

	try {
		Application->Initialize();
		Application->ShowMainForm = false;		//\ŋN
		Application->Title = "HotQ";
		Application->CreateForm(__classid(THotQMainForm), &HotQMainForm);
		Application->CreateForm(__classid(TCmdLncForm), &CmdLncForm);
		Application->CreateForm(__classid(TClipBdList), &ClipBdList);
		Application->CreateForm(__classid(THotKeyHelp), &HotKeyHelp);
		Application->Run();
	}
	catch (Exception &exception) {
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}

	::CloseHandle(hMutex);
	return 0;
}
//---------------------------------------------------------------------------
